{
Windows with exclusive access in the XView-PC interface
By Antonio Carlos Moreirao de Queiroz - acmq@coe.ufrj.br
Version 1.0 - 10/04/94

Procedure similar to "open_window", but with the control returning to the
calling point when the window "w" is closed.
The window "w" must be initially closed, and its "callbacks" cannot open
windows that are already open.
Use in simple warnings to the user that require immediate response.
Try to use "open_window" instead of this procedure whenever possible.
}

PROCEDURE open_exclusive_window(w:Xv_opaque);
VAR
  temp_w:Xv_opaque;
  temp:BOOLEAN;
  VP:ViewPortType;
BEGIN
  temp_w:=active_w;
  temp:=wallpaper;
  wallpaper:=TRUE;
  active_w:=nil;
  GetViewSettings(VP);
  xv_main_loop(w);
  xv_end:=FALSE;
  active_w:=temp_w;
  wallpaper:=temp;
  WITH VP DO SetViewPort(x1,y1,x2,y2,Clip)
END;
